exports.parseXML = function(string) {
    var data = string.toString("utf8");
    var sax = require("sax");
    
    var parser = sax.parser(true, { trim:true });
    parser.onerror = function (e) {
      console.log("XML error: ", e.toString());
      return{};
    };

    var ctag = null;
    var xmlroot = null;
    
    parser.ontext = function (t) {
        if (ctag && t.length > 0) { 
            ctag["data"] = t;
        }   
    }    
    
    parser.onopentag = function (node) {
      var name = node.name;
      var parent = ctag;
      ctag = {};
      ctag.array = [];
      ctag.idFlag = false;   // same tags at same level
      if (xmlroot === null) {
        xmlroot = {};
        xmlroot[name] = ctag;
      }
      else
      {
        ctag.parent = parent;
        var xtag = {};
        xtag[name]= ctag;
        parent.array.push(xtag);
      }
      
      for(var k in node.attributes) {
        ctag[k] = node.attributes[k];
      }

      while(parent && !parent.idFlag) 
      {
          for(var i=0; i < parent.array.length - 1; i++) 
          {
            var elem = parent.array[i];
            for(var key in elem) 
            {
              if(key == name) parent.idFlag=true;
              break;
            }
          }
          break;
      }  
    };

    parser.onclosetag = function(name) {
      if(ctag.idFlag == false) // only one child / all childs different
      {
          for(var i = 0; i < ctag.array.length; i++) {
            var xtag = ctag.array[i];
            for(var u in xtag) {
                ctag[u]=xtag[u];
            } 
          }
          delete ctag.array;
      }
      delete ctag.idFlag;
      if (ctag.parent) {
          var parent = ctag.parent;
          delete ctag.parent;
          ctag = parent;
      }
    }

    parser.write(data).end();
    return xmlroot;
}